# Contributing

- Create an issue or submit a pull request forked from the develop branch.
- For pull requests please refer to steps 1-6 at the top of [Contributing to Simple Icons](https://github.com/simple-icons/simple-icons/blob/develop/CONTRIBUTING.md)

Preconditions for pull request merge:
- For bug fixes a test that fails.
- Documentation and test updates for features.

# Developing

Documentation is generated by Sphinx using doctest, autodoc,
napoleon, and sphinx_rtd_theme.  The docstrings in table.py consumed
by api_*.rst are Google Style docstrings as described by the
sphinx.ext.napoleon documentation.

Tests are executed by pytest.

Versioning complies with Semantic versioning described by
the Python Packaging User Guide.  Please see section
[Choosing a versioning scheme](
https://packaging.python.org/distributing/#choosing-a-versioning-scheme).

The test suite checks that all uses of the
version number are the same.  The developer can update the version number
in __init__.py and then let the test suite failures show the other usages.

Experimental static type checking and code conformance checks are performed
during Continuous Integration.  Errors raised by these tools will not
fail the build.  Please check the log files manually.
